// Generated by CoffeeScript 2.4.1
(function() {
  var $, Fs, HJson, Helpers, Os, Process, Shell, log, pid, port;

  $ = require('bling');

  Fs = require('fs');

  Os = require('os');

  Shell = require('shelljs');

  HJson = require('hjson');

  Process = require('./process');

  Helpers = module.exports;

  log = $.logger("[helper]");

  // Make a helper for reading JSON data (through a Promise)
  Helpers.readJson = function(file, p) {
    if (p == null) {
      p = $.Promise(); // Use a default (empty) promise
    }
    p.wait(function(err, obj) { // Set a default error handler
      if (err) {
        return log("readJson(" + file + ") failed:", err);
      }
    });
    Fs.readFile(file, function(err, data) { // Read the file
      var _err;
      if (err) {
        return p.reject(err);
      }
      try {
        p.resolve(HJson.parse(String(data)));
      } catch (error) {
        _err = error;
        p.reject(_err);
      }
      return null;
    });
    return p;
  };

  Helpers.delay = function(ms) {
    var p;
    p = $.Promise();
    $.delay(ms, p.resolve);
    return p;
  };

  // wait until a certain pid (or it's child) is listening on a port
  Helpers.portIsOwned = function(pid, port, timeout, verbose) {
    var cancel, p, poll_port, started;
    cancel = false;
    try {
      return $.extend(p = $.Promise(), {
        cancel: function() {
          return cancel = true;
        }
      });
    } finally {
      started = $.now;
      (poll_port = function() {
        var target_pids;
        if (cancel) {
          p.resolve(`cancelled pid: ${pid}`);
        }
        if ($.now - started > timeout) {
          return p.reject("Waiting failed after a timeout of: " + timeout + "ms");
        }
        target_pids = [];
        // find all children of our target pid
        return Process.clearCache().findOne({
          pid: pid
        }).then(function(proc) {
          if (cancel || !proc) {
            return p.resolve(`cancelled pid: ${pid}`);
          } else {
            return Process.tree(proc).then(function(tree) {
              Process.walk(tree, function(node) {
                return target_pids.push(node.pid); // build a list of target children
              });
              if (verbose) {
                log("Waiting for targets:", target_pids);
              }
              return Process.findOne({
                ports: port
              }).then((function(owner) {
                if (verbose && (owner != null ? owner.pid : void 0)) {
                  log("Port", port, "currently owned by", owner != null ? owner.pid : void 0);
                }
                // if there is no owner, or the owner is not one of our targets
                if ((!owner) || (!$.matches(owner.pid, target_pids))) {
                  // poll again later
                  if (!cancel) {
                    return setTimeout(poll_port, 300);
                  }
                } else {
                  return p.resolve(owner);
                }
              }), p.reject);
            });
          }
        });
      })();
    }
  };

  if (require.main === module) {
    if (process.argv.length < 4) {
      return;
    }
    port = parseInt(process.argv[2], 10);
    pid = parseInt(process.argv[3], 10);
    Process = require("./process");
    Helpers.portIsOwned(pid, port, 3000).then($.log, console.error.bind(console));
  }

}).call(this);
