// Generated by CoffeeScript 2.4.1
(function() {
  var $, BasicAuth, Express, Helpers, Http, Opts, Static, app, basicAuth, http_password, http_username, i, len, log, method, plain, ref, ref1, ref2, server;

  $ = require('bling');

  Express = require('express');

  BasicAuth = require('basic-auth');

  Http = require('http');

  Static = require('serve-static');

  Helpers = require('./helpers');

  Opts = require('./opts');

  log = $.logger('[http]');

  app = Express();

  app.use(function(req, res, next) {
    log(req.method, req.url, "(-)");
    return next();
  });

  // serve some static js files
  app.use("/static", Static(__dirname + '/../static', {
    index: false
  }));

  // default credentials
  http_username = (ref = Opts.username) != null ? ref : "demo";

  http_password = (ref1 = Opts.password) != null ? ref1 : "demo";

  plain = function(next) {
    return basicAuth(http_username, http_password, function(req, res) { // a plain-text request handler (password-protected)
      res.contentType = "text/plain";
      res.send = function(status, content, enc = "utf8") {
        var err;
        res.statusCode = status;
        try {
          return res.end(content, enc);
        } catch (error) {
          err = error;
          res.statusCode = 500;
          return res.end(String(err), enc);
        }
      };
      res.pass = function(content) {
        return res.send(200, (function() {
          switch ($.type(content)) {
            case "string":
            case "buffer":
              return content;
            case "object":
            case "array":
            case "bling":
              return JSON.stringify(content, null, "  ");
            default:
              return $.toRepr(content);
          }
        })());
      };
      res.html = function(content) {
        res.writeHead(200, {
          "Content-Type": "text/html"
        });
        return res.end(String(content));
      };
      res.fail = function(err) {
        return res.send(500, (function() {
          switch ($.type(err)) {
            case "error":
              return $.debugStack(err);
            case "string":
            case "buffer":
              return err;
            case "object":
            case "array":
            case "bling":
              return JSON.stringify(err);
            default:
              return $.toRepr(content);
          }
        })());
      };
      return next(req, res);
    });
  };

  basicAuth = function(user, pass, next) {
    return function(req, res) {
      var credentials;
      credentials = BasicAuth(req);
      if (!((credentials != null) && credentials.name === user && credentials.pass === pass)) {
        res.writeHead(401, {
          "WWW-Authenticate": 'Basic realm="shepherd"'
        });
        return res.end();
      } else {
        return next(req, res);
      }
    };
  };

  // allow other modules to inject routes by publishing them
  $.subscribe('http-route', function(method, path, handler) {
    method = method.toLowerCase();
    if (Opts.verbose) {
      log("adding published route:", method, path);
    }
    return app[method].call(app, path, plain(handler));
  });

  server = Http.createServer(app);

  $.extend(module.exports, {
    listen: function(port) {
      var _err, p;
      try {
        return p = $.Promise();
      } finally {
        try {
          server.listen(port, function(err) {
            if (err) {
              return p.reject(err);
            } else {
              return p.resolve(port);
            }
          });
        } catch (error) {
          _err = error;
          p.reject(_err);
        }
      }
    },
    close: function() {
      var _err, p;
      try {
        return p = $.Promise();
      } finally {
        try {
          server.close(function(err) {
            if (err) {
              return p.reject(err);
            } else {
              return p.resolve();
            }
          });
        } catch (error) {
          _err = error;
          p.reject(_err);
        }
      }
    }
  });

  ref2 = ["get", "put", "post", "delete"];
  for (i = 0, len = ref2.length; i < len; i++) {
    method = ref2[i];
    (function(method) {
      return module.exports[method] = function(path, handler) {
        return $.publish("http-route", method, path, handler);
      };
    })(method);
  }

}).call(this);
