// Generated by CoffeeScript 2.4.1
(function() {
  var $, MongoClient, connect, connected, prepare, prepared;

  MongoClient = require('mongodb').MongoClient;

  $ = require('bling');

  // The database connection has two phases: connected, and prepared
  connected = $.Promise();

  prepared = $.Promise();

  connect = function(url) { // make the network connection to the database
    MongoClient.connect(url, function(err, db) {
      if (err) {
        return connected.reject(err);
      } else {
        return connected.resolve(db);
      }
    });
    return connected;
  };

  prepare = function(opts, db) { // init the capped collection, when done fire the 'prepared' promise
    db.createCollection(opts.collection, {
      capped: true,
      size: opts.size
    }, function(err) {
      if (err) {
        return prepared.reject(err);
      } else {
        return prepared.resolve(db);
      }
    });
    return prepared;
  };

  module.exports.createWriteStream = function(opts) {
    prepared.wait(function(err, db) {
      if (err) {
        return console.error("Failed to prepare MongoDB collection:", err);
      }
    });
    connect(opts.url).then(function(db) {
      return prepare(opts, db);
    });
    return {
      write: function(data, enc) {
        var ts;
        ts = $.now; // save the timestamp first
        // if the connection isn't prepared, queue up the write for when it is
        return prepared.then(function(db) {
          return db.collection(opts.collection).insert({
            ts,
            d: data,
            e: enc
          }, {
            safe: false
          });
        });
      }
    };
  };

}).call(this);
